﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AeRelais
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        AquaComputer.UsbHid.HidControl UsbHid = new AquaComputer.UsbHid.HidControl();
        AquaComputer.TranslationClasses.aquaero_Rev4 aquaero = new AquaComputer.TranslationClasses.aquaero_Rev4();
        int AE_index = -1;

        private int FindAquaero()
        {
            bool Success = false;
            int result = -1;
            AquaComputer.UsbHid.HidControl.myDeviceStruct DeviceUsbData = new AquaComputer.UsbHid.HidControl.myDeviceStruct(); // USB-Daten vom Device

            //check all connected devices
            for (int i = 0; i <= (UsbHid.DeviceArray.Count - 1); i++)
            {
                DeviceUsbData = UsbHid.DeviceArray[i]; // USB-Datensatz des entsprechenden Gerätes buffern

                //the found device is a aqua computer device
                if (DeviceUsbData.DeviceVID == AquaComputer.UsbHid.HidControl.ACVID.AquaComputer)
                {
                    #region if device a aquaero
                    if (DeviceUsbData.DevicePID == AquaComputer.UsbHid.HidControl.ACPID.aquaero_Rev4)
                    {
                        result = i;
                        string UsbReadData = UsbHid.HidDirectReadFromDevice(i, ref Success);
                        if (UsbReadData != null)
                            aquaero.CreateStructureFromString(UsbReadData); // Daten vom Gerät lesen und in Struktur-Klasse übernehmen
                    }
                    #endregion

                }
            }
            return (result);
        }

        private void Cd_HIDControl_myDeviceDataReceived(int Index, string ReadBuffer, bool Success)
        {
            // Lesen der Daten ueber USB beenden

            if (Success == false)
            {
                return;
            }
        }

        private void WriteAeData(AquaComputer.TranslationClasses.aquaero_Rev4 data, AquaComputer.TranslationClasses.aquaero_Rev4.TransferTypeRegister transferType)
        {
            if (AE_index != -1)
            {
                //create the write data from the last read Data
                string WriteData = data.CreateStringFromStructure(transferType);

                //write the data to the device
                UsbHid.HidWriteToDevice(AE_index, WriteData);
            }

        }

        private void USB_DataReceive(int DeviceIndex, string Data, bool result)
        {
            // threadsiche Programmierung von Events, da das empfangen von USB events in einem anderen thread laeuft
            if ((this.InvokeRequired))
            {
                this.Invoke(new AquaComputer.UsbHid.HidControl.DeviceDataReceivedEventHandler(Cd_HIDControl_myDeviceDataReceived), new object[] { DeviceIndex, Data, result });
            }
            else
            {
            Cd_HIDControl_myDeviceDataReceived(DeviceIndex, Data, result);
            }
        }

        private void init()
        {
            Controls.Add(UsbHid);
            UsbHid.PIDArray.Add(AquaComputer.UsbHid.HidControl.ACPID.aquaero_Rev4);
            UsbHid.PIDArray.Add(AquaComputer.UsbHid.HidControl.ACPID.multiswitch_Rev141);
            UsbHid.HidInit();
            UsbHid.HidDeviceDataReceived += new AquaComputer.UsbHid.HidControl.DeviceDataReceivedEventHandler(this.USB_DataReceive);
            AE_index = FindAquaero();
        }

        private void shutdown()
        {
            UsbHid.HidShutdown();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            init();
            if (AE_index != -1)
            {
                if (radioButton1.Checked == true)
                    aquaero.Relay_Status = (AquaComputer.TranslationClasses.aquaero_Rev4.Relay_StatusRegister)25;
                else if (radioButton2.Checked == true)
                    aquaero.Relay_Status = (AquaComputer.TranslationClasses.aquaero_Rev4.Relay_StatusRegister)0;
                else
                    MessageBox.Show("Weder An noch Aus gewaehlt!", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else
                MessageBox.Show("Aquaero nicht gefunden!", "", MessageBoxButtons.OK, MessageBoxIcon.Error);

            WriteAeData(aquaero, AquaComputer.TranslationClasses.aquaero_Rev4.TransferTypeRegister.RAM);
            shutdown();
        }
    }
}
